XGetEventData(3)

NAME
XGetEventData, XFreeEventData, XGenericEventCookie - retrieve and free additional event data through cookies.

SYNTAX

Bool XGetEventData(Display *display, XGenericEventCookie *cookie);

void XFreeEventData(Display *display, XGenericEventCookie *cookie);

ARGUMENTS

display
    Specifies the connection to the X server.

cookie
    Specifies the cookie to free or retrieve the data for.

STRUCTURES
typedef struct {
        int type;
        unsigned long serial;
        Bool send_event;
        Display *display;
        int extension;
        int evtype;
        unsigned int cookie;
        void *data; } XGenericEventCookie;

DESCRIPTION
Some extension require additional memory to store information. For these events, the library returns a with a token ('cookie') unique to this event. The data pointer is undefined until is called.

The function retrieves this extra data for the given cookie. No round-trip to the server is required. If the cookie is invalid or the event is not an event handled by cookie handlers, is returned. If returns the cookie's data pointer points to the memory containing the event information. A client must call to free this memory. returns for multiple calls for the same event cookie.

The function frees the data associated with a cookie. A client must call for each cookie claimed with

EXAMPLE CODE
XEvent event; XGenericEventCookie *cookie = &ev;

XNextEvent(display, &event); if (XGetEventData(display, cookie)) {
    handle_cookie_event(cookie->data); } else
    handle_event(&event); } XFreeEventData(display, cookie);

NOTES
A cookie is defined as unclaimed if it has been returned to the client through but its data has not been retrieved via Subsequent calls to may free memory associated with unclaimed cookies. Multi-threaded X clients must ensure that is called before the next call to

SEE ALSO
XNextEvent(3),
Xlib - C Language X Interface